
-- PERF_PROGRAMMA_MUSICALE
-- PERF_UTILIZZAZIONE
-- PERF_MANIFESTAZIONE

-- PERF_MOVIMENTO_CONTABILE
-- PERF_EVENTI_PAGATI
-- PERF_DIRETTORE_ESECUZIONE

-- DB SUN:
--Test	
--connection: 	dboratest-scan.servizi.siae:1521/SPTEST.NET.SIAE			
--username: 	preprod_user	
--password: 	P73P70D_US34

--Produzione	
--connection: 	dbsun-scan.servizi.siae:1521/SPPRD.NET.SIAE			
--username: 	spei_reader	
--password: 	sp0rt2


-- PERF_PROGRAMMA_MUSICALE
SELECT PM.ID_PROGRAMMA_MUSICALE AS ID_PROGRAMMA_MUSICALE, 
		PM.NUMERO AS NUMERO_PROGRAMMA_MUSICALE, 
		PM.TIPO AS TIPO_PM, 
		PM.SUPPORTO_PM AS SUPPORTO_PM, 
		PM.SUPPORTO_PM AS FOGLIO, 
		PM.DATA_ASSEGNAZIONE AS DATA_ASSEGNAZIONE, 
		PM.DATA_RESTITUZIONE AS DATA_RESTITUZIONE, 
		PM.DATA_COMPILAZIONE AS DATA_COMPILAZIONE, 
		PM.STATO AS STATO_PM, 
		PM.DATA_ANNULLAMENTO AS DATA_ANNULLAMENTO, 
		PM.FOGLIO_SEGUE_DI AS FOGLIO_SEGUE_DI, 
		PM.FOGLIO_SEGUE_DI AS PM_RIFERIMENTO, 
		PM.CAUSA_ANNULLAMENTO AS CAUSA_ANNULLAMENTO, 
    NVL(( SELECT COUNT (1) FROM PM_QUADRO_D PQD WHERE PQD.ID_PROGRAMMA_MUSICALE=PM.ID_PROGRAMMA_MUSICALE),0) AS TOTALE_CEDOLE,
    NVL((
      SELECT 
        SUM(CASE
          WHEN INSTR (NVL (DURATA_ESECUZIONE, 0), ':') > 0
          THEN
             -- siamo nel caso in cui ci sono i due punti
             CASE
                WHEN DECODE (REPLACE (TRANSLATE (NVL (SUBSTR (DURATA_ESECUZIONE,1,INSTR (NVL (DURATA_ESECUZIONE, 0), ':') - 1),'0'),'1234567890','##########'),'#'),NULL, NVL (SUBSTR (DURATA_ESECUZIONE,1,INSTR (NVL (DURATA_ESECUZIONE, 0), ':') - 1),'0'),NULL) IS NOT NULL
                AND DECODE (REPLACE (TRANSLATE (NVL (SUBSTR (DURATA_ESECUZIONE,INSTR (NVL (DURATA_ESECUZIONE, 0),':')+ 1),0),'1234567890','##########'),'#'),NULL, NVL ( SUBSTR ( DURATA_ESECUZIONE, INSTR (NVL (DURATA_ESECUZIONE, 0),':')+ 1),0),NULL) IS NOT NULL
                THEN
                   TO_NUMBER (NVL (SUBSTR (DURATA_ESECUZIONE, 1, INSTR (NVL (DURATA_ESECUZIONE, 0), ':') - 1),'0')) * 60 + TO_NUMBER (NVL (SUBSTR (DURATA_ESECUZIONE,INSTR (NVL (DURATA_ESECUZIONE, 0), ':') + 1),'0'))
                ELSE
                   0
             END
          ELSE
             -- siamo nel caso in cui non ci sono i due punti
             CASE
                WHEN DECODE ( REPLACE (TRANSLATE (DURATA_ESECUZIONE,'1234567890','##########'),'#'),NULL, DURATA_ESECUZIONE, NULL) IS NOT NULL
                THEN
                   TO_NUMBER (DURATA_ESECUZIONE)
                ELSE
                   0
             END
      END)
      FROM PM_QUADRO_D PQD WHERE PQD.ID_PROGRAMMA_MUSICALE=PM.ID_PROGRAMMA_MUSICALE
      ),0) AS TOTALE_DURATA_CEDOLE,
    ( SELECT COUNT (1) FROM PROGRAMMA_MUSICALE_EVENTO PME WHERE PME.ID_PROGRAMMA_MUSICALE = PM.ID_PROGRAMMA_MUSICALE ) AS GIORNATE_TRATTENIMENTO      
	FROM PROGRAMMA_MUSICALE PM 
	WHERE 
  PM.STATO='V' 
		AND 
    TRUNC(PM.DATA_158,'MONTH') = TO_DATE('2017-01','YYYY-MM');
             



-- PERF_UTILIZZAZIONE   
SELECT ID_PROGRAMMA_MUSICALE,
       NUMERO_PROGRAMMA_MUSICALE,
       NVL(CODICE_OPERA,'-') AS CODICE_OPERA,
       NVL(TITOLO_COMPOSIZIONE,'-') AS TITOLO_COMPOSIZIONE,
       NVL(COMPOSITORE,'-') AS COMPOSITORE,
       DURATA,
       DURATA_INFERIORE_60SEC,       
 FROM
  (SELECT PM_QUADRO_D.ID_PROGRAMMA_MUSICALE AS ID_PROGRAMMA_MUSICALE,
              PROGRAMMA.NUMERO AS NUMERO_PROGRAMMA_MUSICALE,
              CODICE_OPERA,
              TITOLO AS TITOLO_COMPOSIZIONE,
                      COALESCE (COMPOSITORE,SUBSTR(ELENCO_COMPOSITORI,1,DECODE(INSTR(ELENCO_COMPOSITORI,','),0,300,INSTR(ELENCO_COMPOSITORI,',')-1)),
                      SUBSTR(ELENCO_AUTORI,1,DECODE(INSTR(ELENCO_AUTORI,','),0,300,INSTR(ELENCO_AUTORI,',')-1)),
                      substr(ELENCO_INTERPRETI,1,decode(INSTR(ELENCO_INTERPRETI,','),0,300,INSTR(ELENCO_INTERPRETI,',')-1))) AS COMPOSITORE,
              (SUBSTR(DURATA_ESECUZIONE,1, INSTR(DURATA_ESECUZIONE,':')-1  ) * 60 ) + SUBSTR(DURATA_ESECUZIONE,INSTR(DURATA_ESECUZIONE,':')+1, LENGTH (DURATA_ESECUZIONE)) AS DURATA,
              TO_NUMBER (NVL (DURATA_ESEC_INFERIORE_A, 0)) AS DURATA_INFERIORE_60SEC,
              ID_PM_QUADRO_D
         FROM PM_QUADRO_D PM_QUADRO_D
              JOIN PROGRAMMA_MUSICALE PROGRAMMA ON PM_QUADRO_D.ID_PROGRAMMA_MUSICALE=PROGRAMMA.ID_PROGRAMMA_MUSICALE   
        WHERE PROGRAMMA.STATO='V' 
          AND TRUNC(PROGRAMMA.DATA_158,'MONTH') = TO_DATE('2017-01','YYYY-MM')
          AND PROGRAMMA.COD_VOCE_INCASSO ='2224'
  )
  UNION               
(
  SELECT PM_QUADRO_D.ID_PROGRAMMA_MUSICALE AS ID_PROGRAMMA_MUSICALE,
              PROGRAMMA.NUMERO AS NUMERO_PROGRAMMA_MUSICALE,
              CODICE_OPERA,
              TITOLO AS TITOLO_COMPOSIZIONE,
                      COALESCE (COMPOSITORE,substr(ELENCO_COMPOSITORI,1,decode(INSTR(ELENCO_COMPOSITORI,','),0,300,INSTR(ELENCO_COMPOSITORI,',')-1)),
                      SUBSTR(ELENCO_AUTORI,1,DECODE(INSTR(ELENCO_AUTORI,','),0,300,INSTR(ELENCO_AUTORI,',')-1)),
                      substr(ELENCO_INTERPRETI,1,decode(INSTR(ELENCO_INTERPRETI,','),0,300,INSTR(ELENCO_INTERPRETI,',')-1))) AS COMPOSITORE,
              (substr(durata_esecuzione,1, instr(durata_esecuzione,':')-1  ) * 60 ) + SUBSTR(DURATA_ESECUZIONE,INSTR(DURATA_ESECUZIONE,':')+1, LENGTH (DURATA_ESECUZIONE)) AS DURATA,
              TO_NUMBER (NVL (DURATA_ESEC_INFERIORE_A, 0)) AS DURATA_INFERIORE_60SEC,
              min(ID_PM_QUADRO_D)
         FROM PM_QUADRO_D PM_QUADRO_D
              JOIN PROGRAMMA_MUSICALE PROGRAMMA ON PM_QUADRO_D.ID_PROGRAMMA_MUSICALE=PROGRAMMA.ID_PROGRAMMA_MUSICALE   
        WHERE PROGRAMMA.STATO='V' 
          AND TRUNC(PROGRAMMA.DATA_158,'MONTH') = TO_DATE('2017-01','YYYY-MM')
          AND PROGRAMMA.COD_VOCE_INCASSO !='2224'
  GROUP BY PM_QUADRO_D.ID_PROGRAMMA_MUSICALE,
                PROGRAMMA.NUMERO,
                      COALESCE (COMPOSITORE,substr(ELENCO_COMPOSITORI,1,decode(INSTR(ELENCO_COMPOSITORI,','),0,300,INSTR(ELENCO_COMPOSITORI,',')-1)),
                      substr(ELENCO_AUTORI,1,decode(INSTR(ELENCO_AUTORI,','),0,300,INSTR(ELENCO_AUTORI,',')-1)),
                      substr(ELENCO_INTERPRETI,1,decode(INSTR(ELENCO_INTERPRETI,','),0,300,INSTR(ELENCO_INTERPRETI,',')-1))),
                TITOLO,
                TO_NUMBER (NVL (DURATA_ESEC_INFERIORE_A, 0)),
                    (substr(durata_esecuzione,1, instr(durata_esecuzione,':')-1  ) * 60 ) + 
                         SUBSTR(DURATA_ESECUZIONE,INSTR(DURATA_ESECUZIONE,':')+1, LENGTH (DURATA_ESECUZIONE)) ,
                CODICE_OPERA
                );


-- PERF_MANIFESTAZIONE
-- Sono state eliminate le colonne che riportano i dati del pm in quanto provocavano un non corretto legame con i PM delle movimentazioni
-- La chiave di questa tabella che consente il join con la PERF_MOVIMENTO_CONTABILE è la ID_EVENTO
SELECT DISTINCT EV.ID_EVENTO,
  EV.DATA_INIZIO AS DATA_INIZIO_EVENTO,
  EV.DATA_FINE AS DATA_FINE_EVENTO,
  EV.ORA_INIZIO AS ORA_INIZIO,
  EV.ORA_FINE AS ORA_FINE,
  S.CODICE_BA AS CODICE_LOCALE,
  L.DENOMINAZIONE AS DENOMINAZIONE_LOCALE,
	STL.COD_COMUNE AS CODICE_COMUNE,
	CL.DESCRIZIONE AS COMUNE_LOCALE,
	PL.DESCRIZIONE AS PROVINCIA_LOCALE,
	RL.DESCRIZIONE AS REGIONE_LOCALE,
  S.CODICE_BA AS CODICE_BA_LOCALE,
	L.CAP AS CAP_LOCALE,
  PL.SIGLA AS SIGLA_LOCALE,
	S.DENOMINAZIONE AS SPAZIO_LOCALE,
	L.COD_GENERE_LOCALE AS GENERE_LOCALE,
	STL.DENOMINAZIONE AS DENOMINAZIONE_LOCALITA,

	O.CODICE_SAP AS CODICE_SAP_ORGANIZZATORE,
	O.PARTITA_IVA AS PARTITA_IVA_ORGANIZZATORE,
	O.CODICE_FISCALE AS CODICE_FISCALE_ORGANIZZATORE,
	O.NOME AS NOME_ORGANIZZATORE,
	CL.DESCRIZIONE AS COMUNE_ORGANIZZATORE,
	PL.DESCRIZIONE AS PROVINCIA_ORGANIZZATORE
FROM 
PROGRAMMA_MUSICALE PM
JOIN PROGRAMMA_MUSICALE_EVENTO PME ON PME.ID_PROGRAMMA_MUSICALE = PM.ID_PROGRAMMA_MUSICALE
JOIN EVENTO EV ON EV.ID_EVENTO = PME.ID_EVENTO
JOIN CLASSE_EVENTO CE ON EV.ID_EVENTO = CE.ID_CLASSE_EVENTO
JOIN SPAZIO S ON S.ID_SPAZIO = CE.ID_SPAZIO
JOIN LOCALE L ON S.ID_LOCALE = L.ID_LOCALE
JOIN CODICE_SPEI CS ON CS.ID_SPAZIO = S.ID_SPAZIO
JOIN ORGANIZZATORE O ON O.ID_ORGANIZZATORE = CE.ID_ORGANIZZATORE
JOIN STRADA STL ON STL.ID_STRADA = L.ID_STRADA
JOIN COMUNE CL ON CL.COD_COMUNE = STL.COD_COMUNE
JOIN PROVINCIA PL ON PL.COD_PROVINCIA = CL.COD_PROVINCIA
JOIN REGIONE RL ON PL.COD_REGIONE = RL.COD_REGIONE
LEFT JOIN STRADA STO ON STO.ID_STRADA = O.ID_STRADA
JOIN COMUNE CLO ON CLO.COD_COMUNE = STO.COD_COMUNE
JOIN PROVINCIA PLO ON PLO.COD_PROVINCIA = CLO.COD_PROVINCIA
JOIN REGIONE RLO ON PLO.COD_REGIONE = RLO.COD_REGIONE
WHERE PM.STATO='V'
AND TRUNC(PM.DATA_158,'MONTH') =TO_DATE('2017-01','YYYY-MM');



